<html>
	<head>
		<meta charset="utf-8"/>
		<script src="wasm_exec.js"></script>
	</head>
	<body>
		<h1>WASM</h1>
    <h2>Experiments</h2>

		<script>

			if (!WebAssembly.instantiateStreaming) { // polyfill
				WebAssembly.instantiateStreaming = async (resp, importObject) => {
					const source = await (await resp).arrayBuffer();
					return await WebAssembly.instantiate(source, importObject);
				};
			} 

			const go = new Go();

			WebAssembly.instantiateStreaming(fetch("main.wasm"), go.importObject).then((result) => {
				go.run(result.instance)

				let data = HelloWorld()
				document.querySelector("h1").innerText = data.message
				document.querySelector("h2").innerText = data.author
			})
			
		</script>
	</body>
</html>
